import os, sys
from mockServerHelper import *

file_prefix = "mockdata"

usage = textwrap.dedent('''
                Error: wrong usage"

                Usage:
                  buildMockMPA.py [subDir] [template_file_name | content_file_name]

                Example:
                  1. buildMockMPA.py
                  2. buildMockMPA.py 1.0
                  3. buildMockMPA.py aps mock_aps_getState_template.json
                  4. buildMockMPA.py 7.3 mock_cpas_createCart.json
                ''')

def upload_mapping_by_type(filePath):
    # upload mappings stored in separate template file
    if filePath.endswith("_template.json"):
        upload_mapping_from_template(filePath)

    # upload mappings stored in a whole file
    else:
        if not filePath.endswith("_body.json"):
            upload_mapping_from_file(filePath)


def upload_all_mappings(rootDir):
    for root, dirs, files in os.walk(rootDir):
        print(root)
        for file in files:
            if file.endswith(".json"):
                filePath = os.path.join(root, file)
                upload_mapping_by_type(filePath)


def upload_all_in_subDir(rootDir, subDir):
    for root, dirs, files in os.walk(rootDir + "/" + subDir):
        print(root)
        for file in files:
            if file.endswith(".json"):
                filePath = os.path.join(root, file)
                upload_mapping_by_type(filePath)


def upload_single_mapping(rootDir, subDir, fileName):
    filePath = os.path.join(rootDir, subDir, fileName)
    upload_mapping_by_type(filePath)


args = sys.argv
argsNum = len(args)

if argsNum == 1:
    upload_all_mappings(file_prefix)
elif argsNum == 2:
    if args[1] == '-h':
        print(usage)
    else:
        upload_all_in_subDir(file_prefix, args[1])
elif argsNum == 3:
    upload_single_mapping(file_prefix, args[1], args[2])
else:
    print(usage)